Index: horde/lib/Browser.php
===================================================================
RCS file: /repository/horde/lib/Browser.php,v
retrieving revision 1.46
diff -U2 -r1.46 Browser.php
--- horde/lib/Browser.php	1 Aug 2002 16:08:43 -0000	1.46
+++ horde/lib/Browser.php	14 Aug 2002 04:41:31 -0000
@@ -77,4 +77,5 @@
                           'wml'        => false,
                           'images'     => true,
+                          'iframes'    => false,
                           'frames'     => true,
                           'tables'     => true,
@@ -155,4 +156,5 @@
                     $this->setFeature('javascript', 1.4);
                     $this->setFeature('dom');
+		    $this->setFeature('iframes');
                     $this->setFeature('utf');
                     $this->setQuirk('scrollbar_in_way');
@@ -162,4 +164,5 @@
                     $this->setFeature('javascript', 1.4);
                     $this->setFeature('dom');
+		    $this->setFeature('iframes');
                     $this->setFeature('utf');
                     if ($this->minorVersion == 5) {
@@ -208,4 +211,5 @@
                     $this->setFeature('javascript', 1.4);
                     $this->setFeature('dom');
+		    $this->setFeature('iframes');
                     break;
 
Index: horde/imp/templates/compose/compose.inc
===================================================================
RCS file: /repository/imp/templates/compose/compose.inc,v
retrieving revision 2.177
diff -U2 -r2.177 compose.inc
--- horde/imp/templates/compose/compose.inc	3 Aug 2002 15:46:49 -0000	2.177
+++ horde/imp/templates/compose/compose.inc	14 Aug 2002 04:41:54 -0000
@@ -137,5 +137,11 @@
 <?php else: ?>
 <tr>
-    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="to" value="<?php echo htmlspecialchars($to) ?>" style="width:500px" onchange="expandField(this)" /><span id='expandingto' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span></td>
+    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="to" value="<?php echo htmlspecialchars($to) ?>" style="width:500px" 
+    <?php if ($browser->hasFeature('iframes')): ?>
+onchange="expandField(this)" /><span id='expandingto' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span>
+    <?php else: ?>
+    />
+    <?php endif; ?>
+    </td>
 <?php if ($conf['user']['online_help'] && $browser->hasFeature('javascript')): ?>
     <td align="right"><?php echo Help::link('imp', 'compose-to') ?></td>
@@ -193,5 +199,11 @@
 <?php else: ?>
 <tr>
-    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="cc" value="<?php echo htmlspecialchars($cc) ?>" style="width:500px" onchange="expandField(this)" /><span id='expandingcc' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span></td>
+    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="cc" value="<?php echo htmlspecialchars($cc) ?>" style="width:500px" 
+    <?php if ($browser->hasFeature('iframes')): ?>
+onchange="expandField(this)" /><span id='expandingcc' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span>
+    <?php else: ?>
+    />
+    <?php endif; ?>
+    </td>
 <?php if ($conf['user']['online_help'] && $browser->hasFeature('javascript')): ?>
     <td align="right"><?php echo Help::link('imp', 'compose-cc') ?></td>
@@ -249,5 +261,11 @@
 <?php else: ?>
 <tr>
-    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="bcc" value="<?php echo htmlspecialchars($bcc) ?>" style="width:500px" onchange="expandField(this)" /><span id='expandingbcc' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span></td>
+    <td align="left"><input type="text" size="60" tabindex="<?php echo $tabindex++ ?>" class="fixed" name="bcc" value="<?php echo htmlspecialchars($bcc) ?>" style="width:500px" 
+    <?php if ($browser->hasFeature('iframes')): ?>
+onchange="expandField(this)" /><span id='expandingbcc' style='color:red;visibility:hidden;'><?php echo _("Expanding...") ?></span>
+    <?php else: ?>
+    />
+    <?php endif; ?>
+    </td>
 <?php if ($conf['user']['online_help'] && $browser->hasFeature('javascript')): ?>
     <td align="right"><?php echo Help::link('imp', 'compose-bcc') ?></td>